(function($) {
  $.extend($.fn, {
    fileUpload: function(opts) {
      this.each(function() {
        var $self = $(this);
        var doms = {
          "fileToUpload": $self.find(".fileToUpload"),
          "fileDetail": $self.find(".fileDetail"),
          "progress": $self.find(".upload-progress")
        };
        var funs = {
          //选择文件，获取文件大小，也可以在这里获取文件格式，限制用户上传非要求格式的文件
          "fileSelected": function() {
            var files = (doms.fileToUpload)[0].files;
			var count = files.length;
			if(count>1){
				alert2("一次只能上传一个文件!");
			}else{
				var file = files[0];
                var type = file.type;
                if (type == ""||type=="text/plain"||type=="application/vnd.ms-excel"||type=="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"){
					if (file.size > 1024 * 1024 * 10){
						alert2("上传文件大小需小于10M！");
						return;
					}
					funs.uploadFile();
				} else {
					alert2("只支持.txt,.xls,.xlsx文件的上传!");
				}
			}
          },
          //异步上传文件
          uploadFile: function() {
            var fd = new FormData();//创建表单数据对象
            var files = (doms.fileToUpload)[0].files;
            var count = files.length;
            for (var index = 0; index < count; index++) {
				var file = files[index];
				fd.append(opts.file, file);//将文件添加到表单数据中
				if(file.type=="text/plain")
					funs.previewfile(file);//预览txt
				else
					funs.previewfilexls(file);//预览excel
            }
            var xhr = new XMLHttpRequest();
            xhr.upload.addEventListener("progress", funs.uploadProgress, false);//监听上传进度
            xhr.addEventListener("load", funs.uploadComplete, false);
            xhr.addEventListener("error", opts.uploadFailed, false);
            xhr.open("POST", opts.url);
            //xhr.send(fd);
          },
          //txt文件预览
          previewfile: function(file) {
			var str = '';
			var reader=new FileReader();   
			reader.readAsText(file,'gb2312');   
			reader.onload=function(evt){    
                var data = evt.target.result;
                data = data.replace(/(\r)*\n/g, ','); 
                data = $('#fileDetail').text() + ',' + data; //可重复导入数据
                data = data.match(/1[3456789]\d{9}/g);//截取字符串中的手机号码为数组
                data = funs.recUnique(data);//联系人去空、去重
                str = data.join(',');
				$('#fileDetail').html(str);
				$('#count').html(data.length);
			}
          },
          //excel文件预览
          previewfilexls: function(file) {
			var reader = new FileReader();
			reader.onload = function(e) {        
				var data = e.target.result;        
                var workbook = XLSX.read(data, { type: 'binary' }); 

			
				var sheetNames = workbook.SheetNames; // 工作表名称集合
				var worksheet = workbook.Sheets[sheetNames[0]]; // 这里我们只读取第一张sheet
				var txt = XLSX.utils.sheet_to_txt(worksheet);
                $('#fileDetail').html($('#fileDetail').text() + txt); //可重复导入数据
				
                var str = $('#fileDetail').text();
                str = str.replace(/\s+/g, ','); //优化，在获取号码时避免字符太多造成的空白数据

                var data = str.match(/1[3456789]\d{9}/g);//截取字符串中的手机号码为数组
				data = funs.recUnique(data);//联系人去空
				str = data.join(',');
				$('#fileDetail').html(str);
				$('#count').html(data.length);
			};
			reader.readAsBinaryString(file);
			
          },
		  //联系人去空、去重
            recUnique: function (evt) {

                var tmpArr=[];
                for (var i = 0; i < evt.length; i++) {
                    if (evt[i]) tmpArr.push(evt[i]);
                }
                evt = tmpArr;
			    return evt;
          },

          uploadProgress: function(evt) {
            if (evt.lengthComputable) {
              var percentComplete = Math.round(evt.loaded * 100 / evt.total);
              doms.progress.html(percentComplete.toString() + '%');
            }
          },
          "uploadComplete": function(evt) {
            alert(evt.target.responseText)
          }
        };
        doms.fileToUpload.on("change", function() {
          doms.progress.find("span").width("0");
          funs.fileSelected();
        });
      });
    }
  });
})(Zepto);
